From 80cb43833a8e9dd4bf88e70afb4337d70451f6c5 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Jun 30 2016 10:04:07 +0000
Subject: [PATCH 503/1001] Add a method to check if a given URL is safe to return to


---

diff --git a/hubs/app.py b/hubs/app.py
index 81c77d6..98c86a1 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -3,6 +3,7 @@ import functools
 import json
 import logging
 import os
+import urlparse
 import uuid
 
 import flask
@@ -75,6 +76,17 @@ def authenticated():
         and flask.g.auth.logged_in
 
 
+def is_safe_url(target):
+    """ Checks that the target url is safe and sending to the current
+    website not some other malicious one.
+    """
+    ref_url = urlparse.urlparse(flask.request.host_url)
+    test_url = urlparse.urlparse(
+        urlparse.urljoin(flask.request.host_url, target))
+    return test_url.scheme in ('http', 'https') and \
+        ref_url.netloc == test_url.netloc
+
+
 @app.template_filter('commas')
 def commas(numeric):
     return "{:,.2f}".format(numeric)

